# -------------------------------------------------
# Convert Phantasie II TWN2x files
# Ruby script written by Franck "hitchhikr" Charlet (hhhikr@gmail.com).
# -------------------------------------------------

# -------------------------------------------------
# Program entry point
# -------------------------------------------------

    print "TWN2x converter v1.0b\n"
    print "Written by Franck Charlet.\n"

# -------------------------------------------------
# Check command line arguments
    unless ARGV.length <= 2 && ARGV.length >= 1
        print "\nUsage: " + $0 + " <TWN2x.BIN> [TWN2x_CONV.BIN]\n"
        exit
    end

    source_name = ARGV[0]

    # Create the output name if necessary
    if(ARGV.length < 2)
        dest_name = File::dirname(source_name) + File::ALT_SEPARATOR + File.basename(source_name, File.extname(source_name)) + "_CONV.BIN"
    else
        dest_name = ARGV[1]
    end

    print "\nConverting " + source_name + " to " + dest_name + ".\n"

    fin = File.open(source_name, 'rb')
    fout = File.open(dest_name, 'wb')

    i = 0
    # Items stock
    while i < 180 do
        fout.putc(fin.getc())
        i += 1
    end

    # Prices modifiers depending on party's level
    # Since index is always multiplied by 3 i assume that
    # only the first value is used (i may be wrong)
    while i < 225 do
        fout.putc(fin.getc())
        i += 1
        fin.getc()
        i += 1
        fin.getc()
        i += 1
    end
    fout.putc(fin.getc())
    i += 1

    # Multiplier (now aligned on word boundary)
    fout.putc(0)
    fout.putc(fin.getc())
    i += 1
    #~We don't need those 3
    # OUTTx number
    fin.getc()
    i += 1
    # X
    fin.getc()
    i += 1
    # Y
    fin.getc()
    i += 1

    # Town's name
    while i < 250 do
        char = fin.getc()
        if char < 32
            char = 0
        end
        fout.putc(char)
        i += 1
    end    

    fout.close()
    fin.close()

    print "Done.\n"
